;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; ROCKS OFF! - A VERY SIMPLE RAPTOR EXAMPLE
;;
;; RAPTOR USER FILE
;;
;; Note: 	This file, and all other files, are tabulated for Notepad++
;;			Tabulation might be incorrect in other editors.
;;			use Notepad++ for maximum readability. 
;;


;; DO NOT MODIFY THE FOLLOWING LINES

			include				"../../JAGUAR.INC"										; Include JAGUAR system labels
			include				"../../RAPTOR/INCS/RAPTOR.INC"							; Include RAPTOR library labels
			include				"../../U235SE.021/U235SE.INC"							; Include U235SE library labels

			.text							

;; YOUR APPLICATION GOES HERE
;; MODIFY AWAY!
						
;; VIDEO SETUP EQUATES
			
raptor_video_mode				equ				vidRGB16								; tell RAPTOR we want RGB 16 mode
raptor_video_enabled			equ				vidENABLE								; tell RAPTOR we want to Video ENABLED
raptor_video_VARMOD				equ				vidVARMOD_OFF							; tell RAPTOR we want VARMOD disabled
			
;; MAP MODULE SETUP EQUATES
			
raptor_first_map_object			equ				0										; Point RAPTOR to the first obejct of the map data
raptor_map_tiles_per_y			equ				0										; tell RAPTOR the height (in tiles) to display
raptor_map_tiles_per_x			equ				0										; tell RAPTOR the width (in tiles) to display
raptor_map_height				equ				0										; tell RAPTOR the map height (in tiles)
raptor_map_width				equ				0										; tell RAPTOR the map width (in tiles)
raptor_tilesize_x				equ				0										; tell RAPTOR the map tilesize (x) in pixels
raptor_tilesize_y				equ				0										; tell RAPTOR the map tilesize (y) in pixels
raptor_tilelinesz				equ				raptor_tilesize_x/2						; calculate the offset to next line of tile data
raptor_tilesize					equ				raptor_tilelinesz*raptor_tilesize_y		; calculate the byte size of a single tile

;; PARTICLE MODULE SETUP EQUATES

raptor_particle_buffer_width	equ				368										; tell RAPTOR the Particle / Text Buffer is 368 pixels wide
raptor_particle_buffer_height	equ				240										; tell RAPTOR the Particle / Text Buffer is 240 pixels high
raptor_particle_pixels			equ				50										; tell RAPTOR the maximum number of particles
raptor_particle_drift_x			equ				0										; tell RAPTOR the Particle Drift Factor (x)
raptor_particle_drift_y			equ				0										; tell RAPTOR the Particle Drift Factor (y)

;; some human friendly names

IDbackdrop	equ		0						; Object ID #0 is the Background Picture			
IDparticle	equ		1						; Object ID #1 is the Particle Layer (And the Text Output Buffer)
IDlights	equ		2						; Object ID #1-26 are the Planet Sprites
IDcursor	equ		27						; Object ID #27 is the player's cursor

LIST_game	equ		0						; RAPTOR list ID for the game screen
LIST_splash	equ		1						; RAPTOR list ID for the splash screen

;;
;; The following lines **MUST** be at the start of EVERY RAPTOR APPLICATION
;; They configure the .OBJ file for use
;;	
			move.l	#raptor_video_mode,raptor_vidmode
			move.l	#raptor_video_enabled,raptor_videnable
			move.l	#raptor_video_VARMOD,raptor_varmod
			move.l	#raptor_first_map_object,raptor_maptop_obj
			move.l	#raptor_tilesize_x,raptor_tiles_x
			move.l	#raptor_tilesize_y,raptor_tiles_y
			move.l	#raptor_map_tiles_per_x+2,raptor_tilesperx
			move.l	#raptor_map_tiles_per_y+1,raptor_tilespery
			move.l	#raptor_map_width,raptor_mapwidth
			move.l	#raptor_map_height,raptor_mapheight
			move.l	#raptor_particle_pixels,raptor_maxparts
			move.l	#raptor_tilesize_x-1,raptor_tilerem_mask
			move.l	#raptor_particle_buffer_width,raptor_partbuf_x
			move.l	#raptor_particle_buffer_height,raptor_partbuf_y
			move.l	#raptor_particle_drift_x,raptor_pdriftx
			move.l	#raptor_particle_drift_y,raptor_pdrifty
			move.l	#top_of_bss,raptor_top_of_bss
			move.l	#_trashram,raptor_trashram
			move.l	#RAPTOR_MTtrash,raptor_MTwork
			move.l	#RAPTOR_user_vbi,raptor_uvbi_jmp
			move.l	#RAPTOR_POST_Object_List,raptor_poobjl
			move.l	#RAPTOR_PRE_Object_List,raptor_probjl
			move.l	#RAPTOR_font8x8,raptor_8x8_addr
			move.l	#RAPTOR_font8x16,raptor_8x16_addr
			move.l	#RAPTOR_font16x16,raptor_16x16_addr
			move.l	#RAPTOR_particle_palette,raptor_partipal
			move.l	#RAPTOR_particle_gfx,raptor_pgfx
			move.l	#RAPTOR_particle_gfxe,raptor_pgfxe
			move.l	#RAPTOR_sprite_table,raptor_spritetab
			move.l	#RAPTOR_particle_table,raptor_partitab
			move.l	#RAPTOR_MT_app_name,raptor_mtapp
			move.l	#RAPTOR_MT_file_name,raptor_mtfn
			move.l	#raptor_init_table,raptor_inittab
			move.l	#RAPTOR_samplebank,raptor_samplebank_ptr
			move.l	#0,raptor_mapbmptiles					; <<<<---- THIS WILL NEED TO BE CHANGED IF USING THE TILEMAP MODULE <<<<----
			jsr		RAPTOR_HWinit														; Setup Jaguar hardware / install RAPTOR library
			
;;
;; Before we do anything, we have to initialise some stuff.
;;
;; Graphics: In order to minimise development times
;; the graphics are included in a format that can be read from art packages - in this example TGA.
;; What we'll do is: for every bitmap run a routine that converts TGA to Jaguar specific format
;; (RAPTOR_GFXConvert). This routine requires some temp space, and for that we'll use the leftover
;; RAM - "_trashram" points inside the Jaguar's 2MB RAM immediately after every byte we use.
;; Note: because it takes a few seconds to conert all the graphics, we first display and convert
;;       the splash screen and convert the rest, so the user has something to see instead of a
;;       black screen.
;;
;; Sound: The U-235 sound engine is used and all that's needed is a call to its initialiser.
;;

MAINLINE:	lea		minis_bmp,a0														; Points to bitmap
			lea		_trashram,a1														; Workspace RAM
			jsr		RAPTOR_GFXConvert													; Convert TGA to JagBMP

			clr.w	raptor_ticks														; reset frame counter (updated each vertical blank)
			jsr		RAPTOR_start_video													; start video processing (Enable VIDEO OUT)	
			
			move.l	#LIST_splash,d0														; Use the 2nd Display List (We start at 0)
			jsr		RAPTOR_setlist														; (Defined in _RAPINIT.S) - The SPLASH screen
			jsr		RAPTOR_wait_frame_UPDATE_ALL										; Wait a VBlank so it starts processing

			jsr		RAPTOR_U235init														; init the U235 Sound Engine
			lea		mymodule,a0															; point it at a module
			jsr		RAPTOR_U235setmodule												; setup the MOD player
			jsr		RAPTOR_U235gomodule_stereo											; and start it playing
			
			lea		gfx_block,a0														; Points to bitmap (Planets)
			lea		_trashram,a1														; Workspace RAM
			jsr		RAPTOR_GFXConvert													; Convert TGA to JagBMP
			
			lea		gfx_cursor,a0														; Points to bitmap (Cursor)
			lea		_trashram,a1														; Workspace RAM
			jsr		RAPTOR_GFXConvert													; Convert TGA to JagBMP
			
			lea		gfx_backdrop,a0														; Points to bitmap (Backdrop)
			lea		_trashram,a1														; Workspace RAM
			jsr		RAPTOR_GFXConvert													; Convert TGA to JagBMP
			
			jsr		setup_grid															; Setup the initial grid positions of all the objects
			
.waiter:	cmp.w	#8*50,raptor_ticks													; Have 8 seconds passed in PAL land? (slightly less in NTSC)
			bne.s	.waiter																; No, so hang around displaying the SPLASH screen
			
			move.l	#LIST_game,d0														; Use the 1st Display List (We start at 0)
			jsr		RAPTOR_setlist														; (Defined in _RAPINIT.S) - The GAME screen

;;
;; Come here every time a new game is started
;;			

RESETGAME:	jsr		setup_grid															; reset the grid

			move.b	#'-',d1																; assume current level isn't completed
			move.w	currentlevel,d0														; get current level
			lea		completed,a0														; start of level completed table
			add.w	d0,a0																; index it for the correct level
			tst.b	(a0)																; test for completed
			beq.s	.writedone															; if ZERO then its not complete
			move.b	#'+',d1																; else set it as completed
.writedone:	move.b	d1,levtxt+4															; and write the appropriate character into the TEXT output string

			tst.l	raptor_mt_present													; Is there a MemoryTrak connected?
			bmi		.no_memtrack														; Skip if not!
			jsr		RAPTOR_mt_save														; Otherwise, save completed list (Defined in _RAPINIT.S)
.no_memtrack:
						
menuloop:	lea		RAPTOR_sprite_table+(IDcursor*sprite_tabwidth),a0					; point to the CURSOR object
			move.w	#100,sprite_x(a0)													; set its X-position
			move.w	#248,sprite_y(a0)													; set its Y-position (This is offscreen)

			jsr		hide_grid															; hide the game grid
						
;;
;; Loop around here while in the menu
;;
						
.menuloop:	lea		menutext,a0															; points to the menu text
			move.l	#4,d0																; X-position to write at
			move.l	#20,d1																; Y-position to write at
			moveq	#0,d2																; Font Size = 0 (8x8)
			moveq	#0,d3																; Font Index = 0
			jsr		RAPTOR_print														; RAPTOR output text

			jsr		RAPTOR_wait_frame_UPDATE_ALL										; wait a VBlank

			tst.w	debounce															; key 'debounce' timer
			bmi		.test_pad															; if time expired, scan the keypad
			subq.w	#1,debounce															; else decrememnt 'debounce' timer
			bra		.test_b																; and check for B
			
.test_pad:	move.l	U235SE_pad1,d7
			btst	#U235SE_BBUT_UP,d7													; UP pressed?
			beq		.test_down															; if not, branch
			
			move.w	#5,debounce															; set 'debounce' timer to 5 Vblanks
			
			cmp.w	#99,currentlevel													; at MAX level?
			beq		.test_b																; if so, skip
			
			add.w	#1,currentlevel														; increment level
			bra		.change_levtext														; change the text onscreen
			
.test_down:	btst	#U235SE_BBUT_DOWN,d7												; DOWN pressed?
			beq		.test_b																; if not, branch
			
			move.w	#5,debounce															; set 'debounce' timer to 5 Vblanks

			tst.w	currentlevel														; at MIN level (0) ?
			beq		.test_b																; if so, skip
			
			sub.w	#1,currentlevel														; decrement level

.change_levtext:			
			moveq	#0,d1																; clear out the register
			move.w	currentlevel,d1														; get LEVEL number (0-99)
			moveq	#1,d4																; Convert 2 digits (See function for details)
			lea		levout,a0															; buffer to output level number DECIMAL ASCII
			jsr		RAPTOR_HEXtoDEC														; RAPTOR hex to decimal ascii conversion
			move.b	levout,levtxt														; copy the buffer into the MENU TEXT
			move.b	levout+1,levtxt+1													; BOTH numerals

			move.b	#'-',d1																; assume current level isn't completed		;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			move.w	currentlevel,d0														; get current level							;; DUPLICATED FROM RESETGAME
			lea		completed,a0														; start of level completed table			;;
			add.w	d0,a0																; index it for the correct level			;; COULD BE A SUBROUTINE
			tst.b	(a0)																; test for completed						;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			beq.s	.writedone															; if ZERO then its not complete
			move.b	#'+',d1																; else set it as completed
.writedone:	move.b	d1,levtxt+4															; and write the appropriate character into the TEXT output string
			
.test_b:	move.l	U235SE_pad1,d7
			btst	#U235SE_BBUT_B,d7													; B pressed?
			beq		.menuloop															; No, so loop around
			
;;
;; THE GAME IS NOW STARTING
;;
			
			jsr		RAPTOR_particle_clear												; CLEAR the screen
						
			jsr		show_grid															; DISPLAY the grid
			
			lea		griddata,a1															; current GRID data
			lea		changedat,a2														; CHANGE table
			move.l	#24,d7																; 5*5=25 -1 = 24 : so 25 times around the loop ;)
.clear:		clr.b	(a1)+																; clear the GRID
			move.b	#255,(a2)+															; Set the CHANGE flag
			dbra	d7,.clear															; Loop around
			
			jsr		state_change														; set the state of the grid to OFF
			
			move.w	currentlevel,d0														; current level
			mulu	#25,d0																; 25 bytes per level, offset to correct level data
			lea		leveldata,a0														; start of level data
			add.w	d0,a0																; add the offset
			move.l	#24,d7																; 25 times around the loop
			lea		griddata,a1															; pointer to current grid data
			lea		changedat,a2														; pointer to change set
.init:		move.b	(a0),(a1)+															; write into level data
			move.b	(a0)+,(a2)+															; write again into change set
			dbra	d7,.init															; loop
			
			jsr		state_change														; set the state of the grid to LEVEL START data
			
			lea		RAPTOR_sprite_table+(IDcursor*sprite_tabwidth),a0					; pointer to CURSOR object data
			move.w	#76,sprite_x(a0)													; X-position
			move.w	#26,sprite_y(a0)													; Y-position
						
;;;;;;
;;;;;; MAINLOOP
;;;;;;

MAINLOOP:	jsr		RAPTOR_wait_frame_UPDATE_ALL										; wait a VBlank

;; check if we 'won' - LIGHTS OUT!
			
			lea		griddata,a0															; pointer to current grid data
			moveq	#24,d7																; 25 times around loop
			moveq	#0,d0																; clear the flag
.checker:	add.b	(a0)+,d0															; add current state to flag
			dbra	d7,.checker															; loop around
			tst.w	d0																	; are we still zero?
			bne		.not_complete														; no, then branch
			
;; we won ;)
			
.victory:	move.w	currentlevel,d0														; get current level
			lea		completed,a0														; start of level index
			move.b	#1,(a0,d0.w)														; write a '1' meaning we solved it
			bra		RESETGAME															; and back to the menu!
			
.not_complete:
			move.l	U235SE_pad1,d7	
			btst	#U235SE_BBUT_HASH,d7												; Check for #
			beq		.no_exit
			btst	#U235SE_BBUT_STAR,d7												; Check for *
			bne		RESETGAME															; reset the game!
			
.no_exit:	tst.w	cursor_del															; movement 'debounce' counter - can we move yet?
			bmi		.pup																; if so (time expired) then process movement
			sub.w	#1,cursor_del														; else, decrement 'debounce' counter
			bra		.move_done															; and we're done for now
			
.pup:		move.l	U235SE_pad1,d7
			btst	#U235SE_BBUT_UP,d7													; UP pressed?
			beq		.pdown																; no, branch
			move.w	#10,cursor_del														; No more movement for 10 Vblanks
			cmp.w	#26,cursor+2														; are we at the top row?
			beq		.upwrap																; yes, branch for wrap
			sub.w	#40,cursor+2														; move UP one row (40 pixels)
			sub.w	#1,gridpos+2														; move UP in grid index (Y)
			bra		.dpad_left															; process horizontal
.upwrap:	add.w	#40*4,cursor+2														; jump to bottom row (cursor position)
			add.w	#4,gridpos+2														; jump to bottom row (index pointer)
			bra		.dpad_left															; process horizontal
			
.pdown:		btst	#U235SE_BBUT_DOWN,d7												; DOWN pressed?
			beq		.dpad_left															; no, branch
			move.w	#10,cursor_del														; No more movement for 10 Vblanks
			cmp.w	#186,cursor+2														; are we at the bottom row?
			beq		.downwrap															; yes, branch for wrap
			add.w	#40,cursor+2														; move DOWN one row (40 pixels)
			add.w	#1,gridpos+2														; move DOWN in grid index (Y)
			bra		.dpad_left															; process horizontal
.downwrap:	sub.w	#40*4,cursor+2														; jump to top row (cursor position)
			sub.w	#4,gridpos+2														; jump to top row (index pointer)

.dpad_left:	btst	#U235SE_BBUT_LEFT,d7												; LEFT pressed?
			beq		.dpad_right															; no, branch
			move.w	#10,cursor_del														; No more movement for 10 Vblanks
			cmp.w	#76,cursor															; are we at the left edge?
			beq		.leftwrap															; yes, branch for wrap
			sub.w	#40,cursor															; move LEFT one column (cursor)
			sub.w	#1,gridpos															; move LEFT one column (index pointer)
			bra		.update_obj															; update the cursor object
.leftwrap:	add.w	#40*4,cursor														; jump to RIGHT column (cursor)
			add.w	#4,gridpos															; jump to RIGHT column (index pointer)
			bra		.update_obj															; update the cursor object
			
.dpad_right:btst	#U235SE_BBUT_RIGHT,d7												; RIGHT pressed?
			beq		.update_obj															; no, branch
			move.w	#10,cursor_del														; No more movement for 10 Vblanks
			cmp.w	#236,cursor															; are we at the right edge?
			beq		.rightwrap															; yes, branch for wrap
			add.w	#40,cursor															; move RIGHT one column (cursor)
			add.w	#1,gridpos															; move RIGHT one column (index pointer)
			bra		.update_obj															; update the cursor object
.rightwrap:	sub.w	#40*4,cursor														; jump to RIGHT column (cursor)
			sub.w	#4,gridpos															; jump to RIGHT column (index pointer)
			
.update_obj:
			lea		RAPTOR_sprite_table+(IDcursor*sprite_tabwidth),a0					; pointer to CURSOR object data
			move.w	cursor,sprite_x(a0)													; write new X
			move.w	cursor+2,sprite_y(a0)												; write new Y
	
			move.l	U235SE_pad1,d7
			btst	#U235SE_BBUT_B,d7													; B pressed?
			beq		.move_done															; No, so movement is done
			move.w	#10,cursor_del														; set 'debounce' delay
			
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; And here is the ENTIRE GAME LOGIC for this really simple game
;; 
			lea		griddata,a0															; pointer to the grid data values
			lea		changedat,a1														; pointer to the 'change state' values
			move.w	gridpos+2,d0														; get Y position
			move.w	d0,d1																; store it				- YES THIS COULD BE A MULT #5,D0 - BUT HOW
			add.w	d0,d0																; add it (x2)			- CHEAP WOULD THIS LOOK WITH EVEN LESS CODE!!!
			add.w	d0,d0																; add it again (x4)		- 
			add.w	d1,d0																; add stored value (x5) - ITS GOOD PRACTICE TO AVOID MULT/DIV INSTRUCTIONS
			add.w	gridpos,a0															; add x offset to grid pointer
			add.w	gridpos,a1															; add x offset to change pointer
			add.w	d0,a0																; add y offset to grid pointer
			add.w	d0,a1																; add y offset to change pointer
			eor.b	#$ff,(a0)															; TOGGLE THE LIGHT VALUE (!!!!)
			move.b	#1,(a1)																; and set changestate to 'CHANGED'

;;
;; Now do surrounding lights
;;
			cmp.w	#26,cursor+2														; Are we on the top line?
			beq		.do_below															; if yes, skip over these
			eor.b	#$ff,-5(a0)															; TOGGLE LIGHT ABOVE
			move.b	#1,-5(a1)															; and set changestate to 'CHANGED'
.do_below:	cmp.w	#186,cursor+2														; Are we on the bottom line?
			beq		.do_left															; if yes, skip over these
			eor.b	#$ff,5(a0)															; TOGGLE LIGHT BELOW
			move.b	#1,5(a1)															; and set changestate to 'CHANGED'
.do_left:	cmp.w	#76,cursor															; Are we on the left column?
			beq		.do_right															; if yes, skip over these
			eor.b	#$ff,-1(a0)															; TOGGLE LIGHT LEFT
			move.b	#1,-1(a1)															; and set changestate to 'CHANGED'
.do_right:	cmp.w	#236,cursor															; Are we on the right column?
			beq		.lights_done														; if yes, skip over these
			eor.b	#$ff,1(a0)															; TOGGLE LIGHT RIGHT
			move.b	#1,1(a1)															; and set changestate to 'CHANGED'
.lights_done:

;;
;; That's it. Shocking, isn't it? And that's not even optimised.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			jsr		state_change														; process the state changes
			
.move_done:	bra		MAINLOOP															; loop around

;;
;; State Changer
;; Shrink/Grow the planets
;;

state_change:
			move.l	#31,d7																; state change takes 32 frames
.zoomloop:	lea		changedat,a0														; pointer to state change table
			lea		RAPTOR_sprite_table+(IDlights*sprite_tabwidth),a1					; pointer to the planets raptor objects
			lea		griddata,a2															; pointer to the required grid data
			move.l	#24,d6																; 25 times around this loop (5x5 grid)
.inner:		move.b	(a2)+,d0															; get this positions required state
			tst.b	(a0)+																; and was it changed?
			beq.s	.nochange															; if not, do nothing
			tst.b	d0																	; was it 'lit' ?
			beq		.scale_down															; if so, scale it down

.scale_up:	sub.l	#$00008000,sprite_x(a1)												; change its x-pos by 1/2 a pixel
			sub.l	#$00008000,sprite_y(a1)												; change its y-pos by 1/2 a pixel
			add.l	#1,sprite_scale_x(a1)												; make it bigger (x)
			add.l	#1,sprite_scale_y(a1)												; make it bigger (y)
			bra		.nochange															; branch

.scale_down:add.l	#$00008000,sprite_x(a1)												; change its x-pos by 1/2 a pixel
			add.l	#$00008000,sprite_y(a1)												; change its y-pos by 1/2 a pixel
			sub.l	#1,sprite_scale_x(a1)												; make it smaller (x)
			sub.l	#1,sprite_scale_y(a1)												; make it smaller (y)

.nochange:	lea		sprite_tabwidth(a1),a1												; next object!
			dbra	d6,.inner															; loop around all 25 lights
			jsr		RAPTOR_wait_frame_UPDATE_ALL										; wait a Vblank
			dbra	d7,.zoomloop														; loop around 32 times (complete transition)
			
			lea		changedat,a0														; pointer to change table
			move.l	#24,d7																; 25 entries
.reset:		clr.b	(a0)+																; clear them all!
			dbra	d7,.reset															; loop around
			rts																			; we're done, return

;;
;; Slide the grid off to the right
;;			
			
hide_grid:
			moveq	#0,d4																; initial offset value
			move.l	#24,d6																; 25 frames of movement
.outer:		move.l	#24,d7																; 25 objects to move
			lea		RAPTOR_sprite_table+(IDlights*sprite_tabwidth),a0					; pointer to first object
			lea		lights_xy,a1														; pointer to x/y co-ordinate data
.setxy:		move.w	(a1),sprite_x(a0)													; write X position
			add.w	d4,sprite_x(a0)														; add the offset
			lea		4(a1),a1															; next X position
.argh1:		lea		sprite_tabwidth(a0),a0												; next object
			dbra	d7,.setxy															; loop all objects
			add.w	#15,d4																; add X increment to offset value
			jsr		RAPTOR_wait_frame_UPDATE_ALL										; wait a VBlank
			dbra	d6,.outer															; loop around
			rts

;;
;; Slide the grid on from the right
;;
			
show_grid:	move.l	#24*15,d4															; initial offset value				
			move.l	#24,d6																; 25 frames of movement
.outer:		move.l	#24,d7																; 25 objects to move
			lea		RAPTOR_sprite_table+(IDlights*sprite_tabwidth),a0					; pointer to first object
			lea		lights_xy,a1														; pointer to x/y co-ordinate data
.setxy:		sub.w	#15,sprite_x(a0)													; subtract X decrement from offset value
			move.l	#is_active,sprite_active(a0)										; tell RAPTOR this sprite is ACTIVE
			move.w	(a1)+,sprite_x(a0)													; store its X-position
			add.w	d4,sprite_x(a0)														; add the incremental offset
			move.w	(a1)+,sprite_y(a0)													; store its Y-position
			lea		sprite_tabwidth(a0),a0												; next object
			dbra	d7,.setxy															; loop all objects
			sub.w	#15,d4																; subtract X decrement from offset value
			jsr		RAPTOR_wait_frame_UPDATE_ALL										; wait a VBlank
			dbra	d6,.outer															; loop around
			rts

;;
;; Setup Grid routine
;;
			
setup_grid:	lea		RAPTOR_sprite_table+(IDlights*sprite_tabwidth),a0					; pointer to first object
			lea		lights_xy,a1														; pointer to x/y co-ordinate data
			move.l	#24,d7																; 25 objects
.setxy:		move.w	(a1)+,sprite_x(a0)													; Initial X
			move.w	(a1)+,sprite_y(a0)													; Initial Y
			move.l	#%00100000,sprite_scale_x(a0)										; Initial Scale (X) - 1:1
			move.l	#%00100000,sprite_scale_y(a0)										; Initial Scale (Y) - 1:1
			lea		sprite_tabwidth(a0),a0												; next object
			dbra	d7,.setxy															; loop all objects
			rts
				
cursor_del:	dc.w	10																	; Cursor 'debounce' delay (In frames)
cursor:		dc.w	76,26																; Cursor screen position (x,y)
gridpos:	dc.w	0,0																	; Data position (x,y)

griddata:	dc.b	255,255,255,255,255													; Initial GRID data - All set!
			dc.b	255,255,255,255,255
			dc.b	255,255,255,255,255
			dc.b	255,255,255,255,255
			dc.b	255,255,255,255,255
			
changedat:	dc.b	0,0,0,0,0															; Initial CHANGE data - nothing changed!
			dc.b	0,0,0,0,0
			dc.b	0,0,0,0,0
			dc.b	0,0,0,0,0
			dc.b	0,0,0,0,0

lights_xy:	dc.w	80,30																; X/Y positions for each light
			dc.w	120,30
			dc.w	160,30
			dc.w	200,30
			dc.w	240,30
			dc.w	80,70
			dc.w	120,70
			dc.w	160,70
			dc.w	200,70
			dc.w	240,70
			dc.w	80,110
			dc.w	120,110
			dc.w	160,110
			dc.w	200,110
			dc.w	240,110
			dc.w	80,150
			dc.w	120,150
			dc.w	160,150
			dc.w	200,150
			dc.w	240,150
			dc.w	80,190
			dc.w	120,190
			dc.w	160,190
			dc.w	200,190
			dc.w	240,190
				
;;
;; Creating Non-RAPTOR objects around the list
;;		

POST_RAPTOR_Object_List:																; RAPTOR Post-List objects go here (Not used!)						
			rts
						
PRE_RAPTOR_Object_List:																	; RAPTOR Pre-List objects go here (Not used!)	
			rts

levout:		dc.b	"0000"																; level number in ascii
debounce:	dc.w	5																	; debounce counter
			
menutext:	dc.b	raptor_t_lf,raptor_t_lf,raptor_t_lf,raptor_t_lf
			dc.b	"         WELCOME TO ROCKS OFF!",raptor_t_lf
			dc.b	"    A SIMPLE LOGIC PUZZLE BY REBOOT",raptor_t_lf
			dc.b	raptor_t_lf
			dc.b	"          STARTING GRID: "
levtxt:		dc.b	"00 ( )",raptor_t_lf
			dc.b	raptor_t_lf
			dc.b	"  FULL INSTRUCTIONS ABOUT HOW TO PLAY",raptor_t_lf
			dc.b	"  CAN BE FOUND ON WIKIPEDIA BY GOOGLING",raptor_t_lf
			dc.b	" FOR 'LIGHTS OUT' OR AT THE REBOOT SITE",raptor_t_lf
			dc.b	"     LOCATED AT:   reboot.atari.org",raptor_t_lf
			dc.b	raptor_t_lf
			dc.b	"  CODE BY CJ  GFX BY sh3  MUSIC BY 505",raptor_t_lf
			dc.b	"             (c) 2012 REBOOT",raptor_t_lf
			dc.b	raptor_t_lf
			dc.b	"            PRESS B TO START!"
			dc.b	raptor_t_quit
			
			.even
						
;;
;; RAPTOR user VBI vector
;;

RAPTOR_user_vbi:	
			rts																			; we're not using this, nothing tied to the vblank

;;
;; Creating Non-RAPTOR objects around the list
;;		

RAPTOR_PRE_Object_List:																	; No unmanaged objects before the list
			rts

RAPTOR_POST_Object_List:																; No unmanaged Objects after the list									
			rts
						
							include		"_RAPPIXL.S"									; RAPTOR particle module user data
							include 	"_RAPINIT.S"									; RAPTOR object user data
							include 	"_RAPU235.S"									; RAPTOR u235se user data

currentlevel:				dc.w	0													; current level
leveldata:					include	"DATA/levels.txt"									; level data for 00-49
							include "DATA/levels2.txt"									; level data for 50-99
							.even
								
							
;;
;; Music
;;
							.dphrase
mymodule:					incbin	"AUDIO/falling.mod" 								; some 505 magic! 
							.dphrase	
;;
;; Graphics
;;
							.dphrase
RAPTOR_font8x8:				incbin	"../../RAPTOR/FONTS/F_8x8.BMP"						; User defined 8x8 fonts
							.dphrase
RAPTOR_font8x16:			incbin	"../../RAPTOR/FONTS/F_8x16.BMP"						; User defined 8x16 fonts
							.dphrase
RAPTOR_font16x16:			incbin	"../../RAPTOR/FONTS/F_16x16.BMP"					; User defined 16x16 fonts
							.dphrase
RAPTOR_particle_palette:	incbin	"../../RAPTOR/FONTS/PARTIPAL.BMP"					; User defined palette for fonts and particles
							.dphrase

gfx_block:					incbin	"DATA/planspi2.tga"									; PLANET bitmap
							.dphrase
gfx_cursor:					incbin	"DATA/cursor.tga"									; CURSOR bitmap
							.dphrase
minis_bmp:					incbin	"DATA/minis.tga"									; SPLASH SCREEN bitmap
							.dphrase
gfx_spacer:		
							.rept	352*2
							dc.b	0													; used to shunt the bitmap down 1 line (LAZY!)
							.endr
gfx_backdrop:				incbin	"DATA/back.tga"										; BACKDROP bitmap
							.dphrase
				
;;
;; BSS SECTION
;;

							.bss
top_of_bss:

RAPTOR_MTtrash:				.ds.b	16384												; Workspace for MemoryTrack routines

							.dphrase
RAPTOR_particle_gfx:		.ds.b	(raptor_particle_buffer_width/2)*raptor_particle_buffer_height	; particle FX buffer
RAPTOR_particle_gfxe:			
							.dphrase
RAPTOR_sprite_table:		.ds.b	sprite_max*sprite_tabwidth							; RAPTOR sprite database
							.dphrase
RAPTOR_particle_table:		.ds.b	raptor_particle_pixels*particle_tabwidth			; RAPTOR particle database
							.dphrase
							
completed:					.ds.b	100													; Table for levels completed							

_trashram:
								
;END OF FILE

				
